﻿// ------------------------------------------------------------------------------------
//
// Dreipunkt                                                     Ulrich Müller 24.11.09
//                                                               Aspire C# 2005 Express
// Dreipunktregelung über die Werte eines Photowiderstandes
// EncoderMotor an M1, Lampe an O7, Photowiderstand an I4
// Lösung auf Basis der Klasse FishFace
//
// ------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFaceTX;

namespace Dreipunkt {
  public partial class DreiMain : Form {
    FishFace tx = new FishFace();
    Mot ReglerMotor = Mot.M1;
    Unv LichtSensor = Unv.I4;
    Out Lichtquelle = Out.O7;

    int SollWert;
    int LimitHigh;
    int LimitLow;
    int ActualValue;

    public DreiMain() {
      InitializeComponent();
    }

    private void numSollwert_ValueChanged(object sender, EventArgs e) {
      SollWert    = (int)numSollwert.Value;
      LimitHigh   = SollWert + 100;
      LimitLow    = SollWert - 100;
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      numSollwert.Value = 700;
      tx.OpenController("COM4");
      tx.SetLamp(Lichtquelle, Dir.On);
      tx.Pause(1234);
      lblStatus.Text = "Ende : ESC-Taste";
      while (!tx.Finish()) {
        ActualValue = tx.GetAnalog(LichtSensor);
        lblIstWert.Text = ActualValue.ToString();
        if (ActualValue < LimitLow)       tx.SetMotor(ReglerMotor, Dir.Right, 400);
        else if (ActualValue > LimitHigh) tx.SetMotor(ReglerMotor, Dir.Left,  400);
        else tx.SetMotor(ReglerMotor, Dir.Off);
        tx.Pause(111);
      }
      tx.CloseController();
      lblStatus.Text = "Das war's";
    }
  }
}