﻿// --------------------------------------------------------------------------------------
//
// TwinMotor.CS                                                    Ulrich Müller 03.11.09
//                                                                 Aspire C# 2005 Express
// Simultanbetrieb von zwei Motoren. Betrieb asynchron bis Stop
// Die Drehzahl der beteiligten Motoren kann einzeln gesteuert werden.
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace FishFaceTX {
  public class TwinMotor : DeviceBase {

    Motor leftMotor;
    Motor rightMotor;

    public TwinMotor(FishControl fc, Ctr ctrId, Mot LeftMotor, Mot RightMotor)
      : base(fc, false, (int)ctrId, 109) {
      base.deviceType = "TwinMotor";
      leftMotor       = new Motor(fc, ctrId, LeftMotor);
      rightMotor      = new Motor(fc, ctrId, RightMotor);
    }

    protected override void EventLoop() {
    }

    public override string ConnectorName {
      get {
        return base.deviceType;
      }
    }

    public void Run(Dir DirLeft, int SpeedLeft, Dir DirRight, int SpeedRight) {
      leftMotor.Go(DirLeft, SpeedLeft);
      rightMotor.Go(DirRight, SpeedRight);
    }

    public void Stop() {
      leftMotor.Off();
      rightMotor.Off();
    }
    public void RunBackward(int SpeedLeft, int SpeedRight) {
      leftMotor.Backward(SpeedLeft);
      rightMotor.Backward(SpeedRight);
    }
    public void RunForward(int SpeedLeft, int SpeedRight) {
      leftMotor.Forward(SpeedLeft);
      rightMotor.Forward(SpeedRight);
    }
    public void Forward() {
      this.Forward(512);
    }
    public void Forward(int Speed) {
      leftMotor.Forward(Speed);
      rightMotor.Forward(Speed);
    }
    public void Backward() {
      this.Backward(512);
    }
    public void Backward(int Speed) {
      leftMotor.Backward(Speed);
      rightMotor.Backward(Speed);
    }
    public void Left() {
      this.Left(512);
    }
    public void Left(int Speed) {
      leftMotor.Off();
      rightMotor.Forward(Speed);
    }
    public void Right() {
      this.Right(512);
    }
    public void Right(int Speed) {
      leftMotor.Forward(Speed);
      rightMotor.Off();
    }
    public void TurnLeft() {
      this.TurnLeft(512);
    }
    public void TurnLeft(int Speed) {
      leftMotor.Backward(Speed);
      rightMotor.Forward(Speed);
    }
    public void TurnRight() {
      this.TurnRight(512);
    }
    public void TurnRight(int Speed) {
      leftMotor.Forward(Speed);
      rightMotor.Backward(Speed);
    }
  }

}
